/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the IceBreaker type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IceBreaker{}

// IceBreaker struct for IceBreaker
type IceBreaker struct {
	CallToActions []IceBreakerCallToActionsInner `json:"call_to_actions,omitempty"`
	Locale *string `json:"locale,omitempty"`
}

// NewIceBreaker instantiates a new IceBreaker object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIceBreaker() *IceBreaker {
	this := IceBreaker{}
	return &this
}

// NewIceBreakerWithDefaults instantiates a new IceBreaker object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIceBreakerWithDefaults() *IceBreaker {
	this := IceBreaker{}
	return &this
}

// GetCallToActions returns the CallToActions field value if set, zero value otherwise.
func (o *IceBreaker) GetCallToActions() []IceBreakerCallToActionsInner {
	if o == nil || IsNil(o.CallToActions) {
		var ret []IceBreakerCallToActionsInner
		return ret
	}
	return o.CallToActions
}

// GetCallToActionsOk returns a tuple with the CallToActions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IceBreaker) GetCallToActionsOk() ([]IceBreakerCallToActionsInner, bool) {
	if o == nil || IsNil(o.CallToActions) {
		return nil, false
	}
	return o.CallToActions, true
}

// HasCallToActions returns a boolean if a field has been set.
func (o *IceBreaker) HasCallToActions() bool {
	if o != nil && !IsNil(o.CallToActions) {
		return true
	}

	return false
}

// SetCallToActions gets a reference to the given []IceBreakerCallToActionsInner and assigns it to the CallToActions field.
func (o *IceBreaker) SetCallToActions(v []IceBreakerCallToActionsInner) {
	o.CallToActions = v
}

// GetLocale returns the Locale field value if set, zero value otherwise.
func (o *IceBreaker) GetLocale() string {
	if o == nil || IsNil(o.Locale) {
		var ret string
		return ret
	}
	return *o.Locale
}

// GetLocaleOk returns a tuple with the Locale field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IceBreaker) GetLocaleOk() (*string, bool) {
	if o == nil || IsNil(o.Locale) {
		return nil, false
	}
	return o.Locale, true
}

// HasLocale returns a boolean if a field has been set.
func (o *IceBreaker) HasLocale() bool {
	if o != nil && !IsNil(o.Locale) {
		return true
	}

	return false
}

// SetLocale gets a reference to the given string and assigns it to the Locale field.
func (o *IceBreaker) SetLocale(v string) {
	o.Locale = &v
}

func (o IceBreaker) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IceBreaker) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CallToActions) {
		toSerialize["call_to_actions"] = o.CallToActions
	}
	if !IsNil(o.Locale) {
		toSerialize["locale"] = o.Locale
	}
	return toSerialize, nil
}

type NullableIceBreaker struct {
	value *IceBreaker
	isSet bool
}

func (v NullableIceBreaker) Get() *IceBreaker {
	return v.value
}

func (v *NullableIceBreaker) Set(val *IceBreaker) {
	v.value = val
	v.isSet = true
}

func (v NullableIceBreaker) IsSet() bool {
	return v.isSet
}

func (v *NullableIceBreaker) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIceBreaker(val *IceBreaker) *NullableIceBreaker {
	return &NullableIceBreaker{value: val, isSet: true}
}

func (v NullableIceBreaker) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIceBreaker) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


